#!/usr/bin/python
# -*-coding:utf-8-*-

from vecteur import *
from math import pi, sin, cos

class Face(object):
    def __init__(self):
        self.up = Vecteur()
        self.rightFace = Vecteur()
        self.out = Vecteur()


    def rotate(self, v, axis, degrees):
        axis = axis.unitaire()
        radians = degrees*pi/180.
        s = sin(radians)
        c = cos(radians)

        return v*c + axis*axis.scalaire(v)*(1. - c) + v.vectoriel(axis) * s


    def rotateFace(self, face, axis, degrees):
        face.up = self.rotate(face.up, axis, degrees)
        face.rightFace = self.rotate(face.rightFace, axis, degrees)
        face.out = self.rotate(face.out, axis, degrees)


class Cube(Face):
    def __init__(self):
        Face.__init__(self)
        self.top = Face()
        self.bottom = Face()
        self.left = Face()
        self.right = Face()
        self.front = Face()
        self.back  = Face()

    def rotateCube(self, axis, degrees):
        self.rotateFace(self.top, axis, degrees)
        self.rotateFace(self.bottom, axis, degrees)
        self.rotateFace(self.left, axis, degrees)
        self.rotateFace(self.right, axis, degrees)
        self.rotateFace(self.front, axis, degrees)
        self.rotateFace(self.back, axis, degrees)
